'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function findMinLexicographicalLCS(N1, N2, isEqual) {
    if (N2 <= 0)
        return [];
    if (N1 <= 0)
        return new Array(N2).fill(-1);
    const dp = calcDpOfLCS(N1, N2, isEqual);
    const paired = new Array(N2).fill(-1);
    for (let len = dp[N1 - 1][N2 - 1], i = N1 - 1; len > 0; --len) {
        for (let j = 0; j < N2; ++j) {
            if (dp[i][j] === len) {
                while (i >= 0 && dp[i][j] === len)
                    i -= 1;
                paired[j] = i + 1;
                break;
            }
        }
    }
    return paired;
}
function findLengthOfLCS(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return 0;
    const dp = calcDpOfLCS(N1, N2, isEqual);
    return dp[N1 - 1][N2 - 1];
}
function calcDpOfLCS(N1, N2, isEqual) {
    if (N1 <= 0 || N2 <= 0)
        return [];
    const dp = new Array(N1);
    for (let i = 0; i < N1; ++i)
        dp[i] = new Array(N2);
    dp[0][0] = isEqual(0, 0) ? 1 : 0;
    for (let i = 1; i < N1; ++i)
        dp[i][0] = dp[i - 1][0] | (isEqual(i, 0) ? 1 : 0);
    for (let j = 1; j < N2; ++j)
        dp[0][j] = dp[0][j - 1] | (isEqual(0, j) ? 1 : 0);
    for (let i = 1; i < N1; ++i) {
        for (let j = 1; j < N2; ++j) {
            dp[i][j] = isEqual(i, j) ? dp[i - 1][j - 1] + 1 : Math.max(dp[i][j - 1], dp[i - 1][j]);
        }
    }
    return dp;
}

exports.calcDpOfLCS = calcDpOfLCS;
exports.findLengthOfLCS = findLengthOfLCS;
exports.findMinLexicographicalLCS = findMinLexicographicalLCS;
